#ifndef CHECKBOXCONFIG_H
#define CHECKBOXCONFIG_H

#include <QtGui>
#include <QScrollArea>
#include "gui_pushbutton.h"
#include "gui_checkbox.h"

class CheckboxConfig : public QDialog
{
    Q_OBJECT
public:
    CheckboxConfig();
    QWidget *buttons;

    QSpinBox *vspin;
    QSpinBox *hspin;
    QSpinBox *xspin;
    QSpinBox *yspin;
    QSlider *vslider;
    QSlider *hslider;
    QSlider *xslider;
    QSlider *yslider;
    QLineEdit *text2;
    QLineEdit *text3;


    Checkbox *button;
private slots:
    void valueChange();
    void onClickChange();
    void textChange();
    void ok();

protected:
    void closeEvent(QCloseEvent *event);
};

#endif // CHECKBOXCONFIG_H
