#ifndef GUI_COMBOBOXCONFIG_H
#define GUI_COMBOBOXCONFIG_H

#include <QtGui>
#include <QScrollArea>
#include "gui_pushbutton.h"
#include "gui_combobox.h"

class ComboBoxConfig : public QDialog
{
    Q_OBJECT
public:
    ComboBoxConfig();
    QWidget *buttons;

    QSpinBox *vspin;
    QSpinBox *hspin;
    QSpinBox *xspin;
    QSpinBox *yspin;
    QSlider *vslider;
    QSlider *hslider;
    QSlider *xslider;
    QSlider *yslider;
    QLineEdit *text2;
    QLineEdit *text3;


    ComboBox *button;
private slots:
    void valueChange();
    void onClickChange();
    void textChange();
    void ok();

protected:
    void closeEvent(QCloseEvent *event);
};

#endif // GUI_COMBOBOXCONFIG_H
