#ifndef CREATEBUTTONDIALOG_H
#define CREATEBUTTONDIALOG_H

#include <QtGui>
#include <QDialog>
#include <QSpinBox>
#include <QLineEdit>
#include <QSlider>
#include "gui_window.h"

class CreateButtonDialog : public QDialog
{
    Q_OBJECT
public:
    CreateButtonDialog(int t, Window *window);
    QSpinBox *vspin;
    QSpinBox *hspin;
    QSpinBox *xspin;
    QSpinBox *yspin;
    QSlider *vslider;
    QSlider *hslider;
    QSlider *xslider;
    QSlider *yslider;
    QLineEdit *text;
    QLineEdit *name;
    QPushButton *button;
    bool bOK;

    int typ;

    QCheckBox *checkbox;
    QComboBox *combo;
    QTextEdit *textedit;
    QTextEdit *richedit;
    QLineEdit *edit;
    QListView *listbox;
private slots:
    void OK();
    void valueChange();
};

#endif // CREATEBUTTONDIALOG_H
