#ifndef LINEEDITCONFIG_H
#define LINEEDITCONFIG_H

#include <QtGui>
#include <QScrollArea>
#include "gui_pushbutton.h"
#include "gui_lineedit.h"

class LineEditConfig : public QDialog
{
    Q_OBJECT
public:
    LineEditConfig();
    QWidget *buttons;

    QSpinBox *vspin;
    QSpinBox *hspin;
    QSpinBox *xspin;
    QSpinBox *yspin;
    QSlider *vslider;
    QSlider *hslider;
    QSlider *xslider;
    QSlider *yslider;
    QLineEdit *text2;
    QLineEdit *text3;
    QCheckBox *pw;
    QCheckBox *number;


    LineEdit *button;
private slots:
    void valueChange();
    void onChangeChange();
    void textChange();
    void ok();

protected:
    void closeEvent(QCloseEvent *event);
};

#endif // LINEEDITCONFIG_H
