#ifndef GUI_MULTILINEEDITCONFIG_H
#define GUI_MULTILINEEDITCONFIG_H

#include <QtGui>
#include <QScrollArea>
#include "gui_pushbutton.h"
#include "gui_multilineedit.h"

class MultiLineEditConfig : public QDialog
{
    Q_OBJECT
public:
    MultiLineEditConfig();
    QWidget *buttons;

    QSpinBox *vspin;
    QSpinBox *hspin;
    QSpinBox *xspin;
    QSpinBox *yspin;
    QSlider *vslider;
    QSlider *hslider;
    QSlider *xslider;
    QSlider *yslider;
    QLineEdit *text2;
    QLineEdit *text3;
    QCheckBox *pw;
    QCheckBox *number;


    MultiLineEdit *button;
private slots:
    void valueChange();
    void onChangeChange();
    void textChange();
    void ok();

protected:
    void closeEvent(QCloseEvent *event);
};

#endif // GUI_MULTILINEEDITCONFIG_H
