//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#ifndef PROJECTCONFIGDIALOG_H
#define PROJECTCONFIGDIALOG_H

#include <QDialog>
#include <QLineEdit>
#include <QComboBox>
#include <QCheckBox>
#include <QSpinBox>
#include "compiler.h"

class ProjectConfigDialog : public QDialog
{
    Q_OBJECT
public:
    ProjectConfigDialog(Compiler *compiler);
    bool bOK;
    QLineEdit *name;
    QComboBox *console;
    QComboBox *ver;
    QComboBox *arch;
    QComboBox *fpu;
    QComboBox *compile;
    QComboBox *typ;
    QComboBox *fehler;
    QSpinBox *stack;
    QCheckBox *object;
    QCheckBox *asmfile;
    QCheckBox *debug;
    QCheckBox *thread;
    QCheckBox *profile;
    QLineEdit *zusatz;
    QTextEdit *view;
    Compiler *compiler2;

private slots:
    void ok();
    void cancle();
    void updateView();
};

#endif // PROJECTCONFIGDIALOG_H
