//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "typedialog.h"
#include "mainwindow.h"

extern MainWindow *main_window;

TypeDialog::TypeDialog(QWidget *parent,Qt::WindowFlags f)
        : QDialog(parent,f)
{
    resize(400,150);
    bOK = false;
    QVBoxLayout *v = new QVBoxLayout;
    QPushButton *button = new QPushButton("...");
    connect(button,SIGNAL(clicked()),this,SLOT(filedialog()));

    path = new QLineEdit;
    name = new QLineEdit;
    v->addWidget(new QLabel(main_window->getSettings()->value("Lang/TypeDialog_Name").toString()));
    QHBoxLayout *h = new QHBoxLayout;
    v->addWidget(name);
    v->addWidget(new QLabel(main_window->getSettings()->value("Lang/TypeDialog_Path").toString()));
    h->addWidget(path);
    h->addWidget(button);
    v->addLayout(h);
    v->addStretch();

    QPushButton *ok = new QPushButton("OK");
    connect(ok,SIGNAL(clicked()),this,SLOT(OK()));
    QPushButton *cancle = new QPushButton("Abbrechen");
    connect(cancle,SIGNAL(clicked()),this,SLOT(cancle()));

    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addStretch();
    h2->addWidget(ok,0,Qt::AlignRight);
    h2->addWidget(cancle,0,Qt::AlignRight);
    v->addLayout(h2);
    setLayout(v);
}




void TypeDialog::filedialog()
{
    QString fileName = QFileDialog::getExistingDirectory(this, "","C:/", QFileDialog::DontResolveSymlinks | QFileDialog::ShowDirsOnly);
    if (fileName.compare("") > 0)
    {
        path->setText(fileName);
    }
}





void TypeDialog::OK()
{
    QMessageBox box;
    if (path->text().isEmpty() == true)
    {
        box.setText(main_window->getSettings()->value("Lang/TypeDialog_Error_Path").toString());
        box.exec();
        return;
    }
    if (name->text().isEmpty() == true)
    {
        box.setText(main_window->getSettings()->value("Lang/TypeDialog_Error_Name").toString());
        box.exec();
        return;
    }
    bOK = true;
    this->done(0);
}







void TypeDialog::cancle()
{
    this->done(1);
}
