#ifndef WEBVIEW_H
#define WEBVIEW_H

#include <QWidget>
#include "mainwindow.h"
#include <QWebView>

class MainWindow;

class WebView : public QWidget
{
    Q_OBJECT
public:
    WebView(MainWindow *main,int tabIndex);
    WebView(MainWindow *main,int tabIndex, QString name);
    QWebView *view;
    bool b;
public slots:
    void reload();
    void loadFinish();
    void link(QUrl url);
};

#endif // WEBVIEW_H
