//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#ifndef COMPILER_H
#define COMPILER_H

#include <QWidget>
#include <QProcess>
#include "mainwindow.h"

class MainWindow;

class Compiler : public QWidget
{
    Q_OBJECT
public:
    Compiler(MainWindow *main, QWidget *parent = 0);

    //Set-Funktionen
    void setStack(int i) {stack = i;}
    void setCompile(int i) {compile = i;}
    void setTyp(int i) {typ = i;}
    void setFehler(int i) {fehler = i;}
    void setVer(int i) {ver = i;}
    void setArch(int i) {arch = i;}
    void setObject(bool b) {object = b;}
    void setAssembler(bool b) {assembler = b;}
    void setDebug(bool b) {debug = b;}
    void setThread(bool b) {thread = b;}
    void setProfile(bool b) {profile = b;}
    void setConsole(bool b) {console = b;}
    void setFpu(bool b) {fpu = b;}
    void setZusatz(QString s) {zusatz = s;}
    void setName(QString s) {exeName = s;}
    void setFB(QString s) {fb = s;}

    //Get-Funktionen
    int getStack() {return stack;}
    int getCompile() {return compile;}
    int getTyp() {return typ;}
    int getFehler() {return fehler;}
    int getVer() {return ver;}
    int getArch() {return arch;}
    bool getObject() {return object;}
    bool getAssembler() {return assembler;}
    bool getDebug() {return debug;}
    bool getThread() {return thread;}
    bool getProfile() {return profile;}
    bool getConsole() {return console;}
    bool getFpu() {return fpu;}
    QString getFB() {return fb;}
    QString getZusatz() {return zusatz;}
    QString getName() {return exeName;}
    MainWindow *getParentWindow() {return parentWindow;}

private:
    QTextEdit *view;
    QListWidget *problem;
    QListWidget *error;
    QListWidget *warning;
    QProcess *process;
    MainWindow *parentWindow;
    QString fileName;
    QString text;
    QString exe;
    QString fb;
    MainWindow *main;

    int stack;
    bool object;
    bool assembler;
    bool debug;
    bool thread;
    bool profile;
    bool console;
    bool fpu;
    int compile;
    int typ;
    int fehler;
    QString exeName;
    QString zusatz;
    int ver;
    int arch;

    QProcess *process2;


    QString createToolTip(QStringList string, int start);

private slots:
    void erstellen();
    void erstellenaus();
    void finished(int exitCode, QProcess::ExitStatus exitStatus);
    void finished2(int exitCode, QProcess::ExitStatus exitStatus);
    void tabChange(int index);
    void gotoError(const QModelIndex & index);
    void stopRun();
    void compile_file();
    void compilerun_file();
};

#endif // COMPILER_H
