#ifndef GUI_CREATECOMBOBOX_H
#define GUI_CREATECOMBOBOX_H

#include <QDialog>
#include <QSpinBox>
#include <QLineEdit>
#include <QSlider>
#include <QComboBox>

class CreateComboBox : public QDialog
{
    Q_OBJECT
public:
    CreateComboBox(QWidget *window);
    QSpinBox *vspin;
    QSpinBox *hspin;
    QSpinBox *xspin;
    QSpinBox *yspin;
    QSlider *vslider;
    QSlider *hslider;
    QSlider *xslider;
    QSlider *yslider;
    QLineEdit *text;
    QComboBox *button;
    bool bOK;

private slots:
    void OK();
    void valueChange();
};
#endif // GUI_CREATECOMBOBOX_H
