#ifndef CREATELINEEDITDIALOG_H
#define CREATELINEEDITDIALOG_H

#include <QDialog>
#include <QSpinBox>
#include <QLineEdit>
#include <QSlider>
#include <QCheckBox>

class CreateLineEditDialog : public QDialog
{
    Q_OBJECT
public:
    CreateLineEditDialog(QWidget *window);
    QSpinBox *vspin;
    QSpinBox *hspin;
    QSpinBox *xspin;
    QSpinBox *yspin;
    QSlider *vslider;
    QSlider *hslider;
    QSlider *xslider;
    QSlider *yslider;
    QLineEdit *text;
    QLineEdit *button;
    bool bOK;

private slots:
    void OK();
    void valueChange();
};

#endif // CREATELINEEDITDIALOG_H
