#ifndef MAINWINDOW2_H
#define MAINWINDOW2_H

#include <QtGui>
#include "mainwindow.h"
#include "gui_window.h"
#include "gui_config.h"


class MainWindow2 : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow2(MainWindow *main, int tabIndex, QWidget *parent = 0);
    MainWindow2(QString file, MainWindow *main,QWidget *parent = 0);
    ~MainWindow2();
    QMdiArea *getArea() {return area;}
    Config *config;

protected:
    void closeEvent(QCloseEvent *event);

private:
    void menu();
    Window *win;
    int id;
    MainWindow *main;
    QMdiArea *area;

private slots:
    void createButton();
    void createCheckbox();
    void createLineEdit();
    void createMultiLineEdit();
    void createComboBox();
    void createListBox();
    void createRichEdit();
    void createCode();
};

#endif // MAINWINDOW_H
