//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#ifndef HIGHLIGHTER_H
#define HIGHLIGHTER_H

#include <QSyntaxHighlighter>

struct HighlightingRule
{
    QRegExp ex;
    QTextCharFormat format;
};


//Highlighter Klasse, dient zum hervorheben von Quelltext

class Highlighter : public QSyntaxHighlighter
{
    Q_OBJECT
public:
    Highlighter(QTextDocument *parent,QTextEdit *e);
    QTextCharFormat getFormat(int pos) { return format(pos); }           //Funktioniert nicht wie es soll, wird aber aktuell nicht zwingend bentigt
    void highlight(const QString &string) { highlightBlock(string); }    //das selbe wie bei getFormat()
    QTextCharFormat keywordFormat;                                       //Format fr Schlsselwrter. TODO: set und get Funktionen einfgen und private machen

protected:
    void highlightBlock(const QString &text);
    void highlightStrings(const QString &text);
    int findEnd(const QString &text, int start);


private:
    QList<HighlightingRule> highlightingVector;
    QTextCharFormat datatypeFormat;
    QTextCharFormat numberFormat;
    QTextCharFormat commentFormat;
    QTextCharFormat stringFormat;

    QTextEdit *edit;
};

#endif // HIGHLIGHTER_H
