//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QApplication>
#include <QStyleFactory>
#include <QLocale>
#include <QTranslator>
#include <QLibraryInfo>
#include <QLabel>
#include <QWindowsStyle>
#include "mainwindow.h"





QWindowsStyle *winStyle;
MainWindow *main_window;


int main(int argc, char *argv[])
{
    QSettings *settings = new QSettings("settings.ini",QSettings::IniFormat);                        //Settings laden
    QApplication::setStyle(QStyleFactory::create(settings->value("GUI/style").toString()));          //Style setzen
    QApplication app(argc,argv);
    winStyle = new QWindowsStyle;

    QTranslator qtTranslator;
    qtTranslator.load("qt_" + QLocale::system().name(),QLibraryInfo::location(QLibraryInfo::TranslationsPath));   //Sprache, tut nicht ganz, hat aber mal getan, Fehler wird noch behoben.
    app.installTranslator(&qtTranslator);

    QTranslator myappTranslator;
    myappTranslator.load("myapp_" + QLocale::system().name());
    app.installTranslator(&myappTranslator);

    main_window = new MainWindow(settings);
    main_window->show();


    return app.exec();
}
