#ifndef NOPASTEDIALOG_H
#define NOPASTEDIALOG_H

#include <QtGui>
#include <QtNetwork>
#include <QDialog>
#include "mainwindow.h"

class NoPasteDialog : public QDialog
{
    Q_OBJECT
public:
    NoPasteDialog(MainWindow *main);
    MainWindow *window;
    bool bOK;


private:
    QLineEdit *name;
    QLineEdit *pw;
    QTextEdit *text;
    QNetworkReply *reply;
    QHttp *http;
    QHttp *http2;
    QHttp *httpFile;
    QLineEdit *titeledit;
private slots:
    void OK();
    void cancle();
    void readyToRead();
    void getHash();
    void aboutNoPaste();
    void readAbout();
};

#endif // NOPASTEDIALOG_H
