#ifndef NOPASTEEDITDIALOG_H
#define NOPASTEEDITDIALOG_H

#include <QtGui>
#include <QtNetwork>
#include <QDialog>
#include "mainwindow.h"

class NoPasteEditDialog : public QDialog
{
    Q_OBJECT
public:
    NoPasteEditDialog(MainWindow *main);
    MainWindow *window;
    bool bOK;

    QHttp *http;
    QHttp *http2;
    QHttp *httpList;
    QHttp *httpFile;

private:
    QLineEdit *name;
    QLineEdit *pw;
    QTextEdit *text;
    QNetworkReply *reply;
    QComboBox *listBox;
    QLineEdit *titeledit;
private slots:
    void OK();
    void cancle();
    void openFile();
    void removeFile();
    void readyToRead();
    void readFile();
    void getHash();
    void getHash2();
    void getHash3();
    void getHash4();
    void readList();
    void loadList();
    void deleteFile();
    void aboutNoPaste();
    void readAbout();
};

#endif // NOPASTEDIALOG_H
