//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "mainwindow.h"
#include "projectdialog.h"

//Dialog zum erstellen eines neuen Projekts.
//TODO: Vorlagen

extern MainWindow *main_window;

ProjectDialog::ProjectDialog(QWidget *parent, Qt::WindowFlags f)
        : QDialog(parent,f)
{
    resize(400,350);
    bOK = false;
    QVBoxLayout *v = new QVBoxLayout;
    QListWidget *view = new QListWidget;
    QPushButton *button = new QPushButton("...");
    connect(button,SIGNAL(clicked()),this,SLOT(filedialog()));

    path = new QLineEdit;
    projectName = new QLineEdit;
    v->addWidget(view);
    v->addWidget(new QLabel(main_window->getSettings()->value("Lang/NewProject_Name").toString()));
    QHBoxLayout *h = new QHBoxLayout;
    v->addWidget(projectName);
    v->addWidget(new QLabel(main_window->getSettings()->value("Lang/NewProject_Path").toString()));
    h->addWidget(path);
    h->addWidget(button);
    v->addLayout(h);

    QPushButton *ok = new QPushButton(main_window->getSettings()->value("Lang/Button_OK").toString());
    connect(ok,SIGNAL(clicked()),this,SLOT(OK()));
    QPushButton *cancle = new QPushButton(main_window->getSettings()->value("Lang/Button_Cancle").toString());
    connect(cancle,SIGNAL(clicked()),this,SLOT(cancle()));

    QHBoxLayout *h2 = new QHBoxLayout;
    h2->addStretch();
    h2->addWidget(ok,0,Qt::AlignRight);
    h2->addWidget(cancle,0,Qt::AlignRight);
    v->addLayout(h2);
    setLayout(v);
}









//Dialog zum whlen des Projekt Ordners
void ProjectDialog::filedialog()
{
    QString fileName = QFileDialog::getExistingDirectory(this, main_window->getSettings()->value("Lang/File_Dialog_Titel").toString(),"", QFileDialog::DontResolveSymlinks | QFileDialog::ShowDirsOnly);
    if (fileName.compare("") > 0)
    {
        path->setText(fileName);
    }
}










void ProjectDialog::OK()
{
    QMessageBox box;
    if (path->text().isEmpty() == true)
    {
        box.setText(main_window->getSettings()->value("Lang/NewProject_Error_Path").toString());
        box.exec();
        return;
    }
    if (projectName->text().isEmpty() == true)
    {
        box.setText(main_window->getSettings()->value("Lang/NewProject_Error_Name").toString());
        box.exec();
        return;
    }
    bOK = true;
    this->done(0);
}










void ProjectDialog::cancle()
{
    this->done(1);
}
