//Das Programm hat noch keinen Namen und ist eine IDE fr FreeBASIC
//Copyright (C) 2009  Thomas Stber
//
//This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA





#include <QtGui>
#include "settingsdialog.h"


extern QFont fontEdit;


SettingsDialog::SettingsDialog(QWidget *parent, Qt::WindowFlags f, MainWindow *main)
        : QDialog(parent,f)
{
    parentWindow = main;
    resize(300,100);
    QVBoxLayout *v = new QVBoxLayout;
    QHBoxLayout *h = new QHBoxLayout;
    QHBoxLayout *h2 = new QHBoxLayout;
    QHBoxLayout *h3 = new QHBoxLayout;
    box = new QComboBox();
    fontBox = new QFontComboBox;
    fontBox->setCurrentFont(fontEdit);

    QPushButton *button = new QPushButton("...");
    connect(button,SIGNAL(clicked()),this,SLOT(filedialog()));
    QStringList list = QString("Cleanlooks Plastique Motif CDE System").split(" ");
    box->addItems(list);
    path = new QLineEdit;
    path->setText(main->getSettings()->value("Compiler/Path").toString());
    h2->addWidget(new QLabel(main->getSettings()->value("Lang/ConfigDialog_CompilerPath").toString()));
    h2->addWidget(path);
    h2->addWidget(button);
    v->addLayout(h2);

    h->addWidget(new QLabel(main->getSettings()->value("Lang/ConfigDialog_Design").toString()));
    h->addWidget(box);
    h->addStretch();
    v->addLayout(h);

    h3->addWidget(new QLabel(main->getSettings()->value("Lang/ConfigDialog_Font").toString()));
    h3->addWidget(fontBox);
    h3->addStretch();
    v->addLayout(h3);



    v->addStretch();
    QPushButton *ok = new QPushButton(main->getSettings()->value("Lang/Button_OK").toString());
    connect(ok,SIGNAL(clicked()),this,SLOT(ok()));
    v->addWidget(ok,0,Qt::AlignRight);
    setLayout(v);
}










void SettingsDialog::filedialog()
{
    QString fileName = QFileDialog::getOpenFileName(this, parentWindow->getSettings()->value("Lang/ConfigDialog_CompilerPath_Titel").toString(),"C:/", parentWindow->getSettings()->value("Lang/ConfigDialog_CompilerPath_Type").toString());
    if (fileName.compare("") > 0)
    {
        path->setText(fileName);
    }
}










void SettingsDialog::ok()
{
    bOK = true;
    this->done(0);
}
